<?php
/*
Plugin Name: Simple Amazon
Plugin URI: http://www.icoro.com/
Description: ASIN を指定して Amazon から個別商品の情報を取出します。BOOKS, DVD, CD は詳細情報を取り出せます。
Author: icoro
Version: 2.0.6.1
Author URI: http://www.icoro.com/
Special Thanks: tomokame (http://http://tomokame.moo.jp/)
Special Thanks: websitepublisher.net (http://www.websitepublisher.net/article/aws-php/)
Special Thanks: hiromasa.zone :o) (http://hiromasa.zone.ne.jp/)
Special Thanks: PEAR :: Package :: Cache_Lite (http://pear.php.net/package/Cache_Lite)
Special Thanks: Amazon® AWS HMAC signed request using PHP (http://mierendo.com/software/aws_signed_query/)
*/

/******************************************************************************
 * simple-amazon-function : amazon ECS search engine
 *****************************************************************************/
if( $_SERVER['SCRIPT_FILENAME'] == __FILE__ ) die();

if ( ! defined( 'SIMPLE_AMAZON_PLUGIN_DIR' ) )
	define( 'SIMPLE_AMAZON_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . plugin_basename( dirname( __FILE__ ) ) );

if ( ! defined( 'SIMPLE_AMAZON_PLUGIN_URL' ) )
	define( 'SIMPLE_AMAZON_PLUGIN_URL', WP_PLUGIN_URL . '/' . plugin_basename( dirname( __FILE__ ) ) );

$simple_amazon_settings = get_option('simple_amazon_admin_options');


/******************************************************************************
 * THIS FILE IS CALLED ONLY.
 *****************************************************************************/
include_once(SIMPLE_AMAZON_PLUGIN_DIR . '/simple-amazon-function.php');


/******************************************************************************
 * 管理画面からオプションを設定
 *****************************************************************************/
class SimpleAmazonAdmin {
	var $simple_amazon_settings, $simple_amazon_options;

	function SimpleAmazonAdmin() {
		if ( !get_option('simple_amazon_admin_options') ){
			// create default options
			$simple_amazon_options = array(
				'associatesid'	=> 'icoro-22',
				'windowtarget'	=> 'self',
				'jacketimgsize'	=> 'small',
				'goodsimgsize'	=> 'small',
				'layout_type'	=> '0',
			);
			update_option('simple_amazon_admin_options', $simple_amazon_options);
		}
	}

	function simple_amazon_options_page() {
		global $simple_amazon_settings;
		$simple_amazon_options = get_option('simple_amazon_admin_options');

		$simple_amazon_admin_html =
			'<div class="wrap" id="footnote-options">' . "\n".
			'<h2>Simple Amazon プラグイン設定</h2>' . "\n";

		if ( $_POST['action'] ){
			$simple_amazon_admin_html .= '<div class="updated"><p><strong>設定を保存しました。</strong></p></div>'; 
		}

		switch( $simple_amazon_options['windowtarget']) {
			case newwin: $newwindow = ' checked'; $selfwindow = ''; break;
			case self: $newwindow = ''; $selfwindow = ' checked'; break;
		}

		switch( $simple_amazon_options['jacketimgsize'] ) {
			case medium: $m_jacketsize = ' checked'; $s_jacketsize = ''; break;
			case small: $m_jacketsize = ''; $s_jacketsize = ' checked'; break;
		}

		switch( $simple_amazon_options['goodsimgsize'] ) {
			case medium: $m_goodssize = ' checked'; $s_goodssize = ''; break;
			case small: $m_goodssize = ''; $s_goodssize = ' checked'; break;
		}

		switch( $simple_amazon_options['layout_type'] ) {
			case 0: $default_layout  = ' checked';$medium_layout = '';  $simple_layout = ''; $noimage_layout = ''; break;
			case 1: $default_layout = ''; $medium_layout = ' checked'; $simple_layout = ''; $noimage_layout = ''; break;
			case 2: $default_layout  = ''; $medium_layout = ''; $simple_layout = ' checked'; $noimage_layout = ''; break;
			case 3: $default_layout  = ''; $medium_layout = ''; $simple_layout = ''; $noimage_layout = ' checked'; break;
		}

		$simple_amazon_admin_html .=
			'<form method="post" action="' . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING'] . '">' .
			'<input type="hidden" name="action" value="save_options" />' .
			'<table class="form-table">' .
			'<tr>' . "\n" .
			'<th>あなたのアソシエイト ID</th>' . "\n" .
			'<td><input type="text" name="associatesid" value="' . $simple_amazon_options['associatesid'] . '"  /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr><th>商品リンクの動作</th>' . "\n" .
			'<td><input type="radio" name="windowtarget" value="self"' . $selfwindow . ' />&nbsp;同じウィンドウ（ target 指定なし ）<br />' . "\n" .
			'<input type="radio" name="windowtarget" value="newwin"' . $newwindow . ' />&nbsp;新規ウィンドウ（ target="_blank" ）</td>' . "\n" .
			'</tr>' . "\n" .
			'<tr><th>商品詳細の表示スタイル</th>' . "\n" .
			'<td><input type="radio" name="layout_type" value="0"' . $default_layout . ' />&nbsp;画像、タイトル、出版社、発売時期、著者、価格、本のタイプ、ページ数、ISBN（ 初期設定。本以外はこれに準ずる項目 ）<br />' . "\n" .
			'<input type="radio" name="layout_type" value="1"' . $medium_layout . ' />&nbsp;画像、タイトル、出版社、著者、発売時期（ 初期設定から価格情報とコード情報を省略 ）<br />' . "\n" .
			'<input type="radio" name="layout_type" value="2"' . $simple_layout . ' />&nbsp;画像とタイトルのみ<br />' . "\n" .
			'<input type="radio" name="layout_type" value="3"' . $noimage_layout . ' />&nbsp;タイトルのみ</td>' . "\n" .
			'</tr>' . "\n" .
			'<tr><th>CD ジャケットの画像サイズ</th>' . "\n" .
			'<td><input type="radio" name="jacketimgsize" value="small"' . $s_jacketsize . ' />&nbsp;小サイズ（ 初期設定 ）<br />' . "\n" .
			'<input type="radio" name="jacketimgsize" value="medium"' . $m_jacketsize . ' />&nbsp;中サイズ</td>' . "\n" .
			'</tr>' . "\n" .
			'<tr><th>その他（ 本、DVD、CD 以外 ）の画像サイズ</th>' . "\n" .
			'<td><input type="radio" name="goodsimgsize" value="small"' . $s_goodssize . ' />&nbsp;小サイズ（ 初期設定 ）<br />' . "\n" .
			'<input type="radio" name="goodsimgsize" value="medium"' . $m_goodssize . ' />&nbsp;中サイズ</td>' . "\n" .
			'</tr>' . "\n" .
			'</table>' . "\n" .
			'<p class="submit"><input type="submit" name="Submit" value="設定を保存する &raquo;" /></p>' . "\n" .
			'</form>' . "\n" .
			'</div>' . "\n";

			echo $simple_amazon_admin_html;
	}

	function simple_amazon_add_options() {
		// Add a new menu under Options:
		add_options_page(
			'Simple Amazon',
			'Simple Amazon',
			8,
			__FILE__,
			array(&$this, 'simple_amazon_options_page')
		);
	}
	
	function simple_amazon_save_options() {
		// create array
		$simple_amazon_options = array(
			'associatesid'	=> $_POST['associatesid'],
			'windowtarget'	=> $_POST['windowtarget'],
			'jacketimgsize'	=> $_POST['jacketimgsize'],
			'goodsimgsize'	=> $_POST['goodsimgsize'],
			'layout_type'	=> $_POST['layout_type'],
		);

		update_option('simple_amazon_admin_options', $simple_amazon_options);
		$options_saved = true;
	}

}


/******************************************************************************
 * 記事本文中に Amazon から取得した商品情報を表示
 *****************************************************************************/
class SimpleAmazonView {

	/**
	 * The Constructor
	 * 
	 * @param none
	 * @return none
	 */

	function SimpleAmazonView() {

		$this->makedetailview = & new MakeSimpleAmazonHtml();

	}

	/**
	 * 記事本文中のコードを個別商品表示 HTML に置き換える
	 * 
	 * @param $content
	 * @return $transformedstring
	 */
	function _replacestrings($content) { // 記事本文中の呼び出しコードを変換

		global $post;

//		$poststring = '/\[tmkm-amazon\]([a-zA-Z0-9,]+)\[\/tmkm-amazon\]/';
		$poststring = '/<amazon>([a-zA-Z0-9,]+)<\/amazon>/';

		$transformedstring = $content;
		if( preg_match_all($poststring, $content, $regs1) ) {

			for ($i=0; $i<count($regs1[0]); $i++) {

				$SearchString = $regs1[1][$i];
				$display = $this->makedetailview->format_amazon( $SearchString, 'detail' );

				if( ereg( $SearchString, $regs1[0][$i], $str ) ) { // ASINコードの置換
					$transformedstring = str_replace($regs1[0][$i], $display, $transformedstring);
				}

			}
		}

		$transformedstring = str_replace('<p><div class="simple-amazon-view">', '<div class="simple-amazon-view">', $transformedstring);
		$transformedstring = str_replace('<hr class="simple-amazon-clear" /></div></p>', '<hr class="simple-amazon-clear" /></div>', $transformedstring);

		return $transformedstring;

	}


	/**
	 * PHP 関数として Amazon の個別商品 HTML を呼び出す
	 * 
	 * @param $SearchString ( ASIN )
	 * @param $type ( book / dvd / cd )
	 * @return echo $display ( HTML )
	 */
	function simple_amazon_view( $SearchString ) { // PHP テ−マファイル中に記述する関数
		$display = $this->makedetailview->format_amazon( $SearchString, 'detail' );
		echo $display;
	}

}


/******************************************************************************
 * Amazon ECS から取得した XML から HTML を生成
 *****************************************************************************/
class MakeSimpleAmazonHtml {
	var $plugin_path;
	var $mediumimgfile;
	var $smallimgfile;
	var $associatesid;

	function MakeSimpleAmazonHtml() {

		$this->amazonparse = & new GetSimpleAmazonXmlParse();
		$this->generalfunclib = & new CalcISBNLibrary();

	}

	/**
	 * Amazon 商品の HTML ソースを生成
	 * @param $SearchString ( ASIN )
	 * @param $mediatype ( book / dvd / cd )
	 * @return $output ( HTML )
	 */
	function format_amazon( $SearchString, $formattype ) {
		global $simple_amazon_settings;

        $this->mediumimgfile = '/amazon_noimg.png';
        $this->smallimgfile = '/amazon_noimg_small.png';
        $associatesid = $simple_amazon_settings['associatesid'];

        switch( $simple_amazon_settings['windowtarget']) {
        	case newwin: $windowtarget = ' target="_blank"'; break;
        	case self: $windowtarget = '';
        }

		if( strlen( $SearchString ) == 13 ){
			$SearchString = $this->generalfunclib->calc_chkdgt_isbn10( substr( $SearchString, 3, 9 ) );
		}

		// --- Call Amazon XML function ---
		if( $simple_amazon_settings['layout_type'] == '2' ) {
			$AmazonXml = $this->amazonparse->getamazonxml( $associatesid, $SearchString, 'Images,Small');
		} elseif( $simple_amazon_settings['layout_type'] == '3' ) {
			$AmazonXml = $this->amazonparse->getamazonxml( $associatesid, $SearchString, 'ItemAttributes');
		} else {
			$AmazonXml = $this->amazonparse->getamazonxml( $associatesid, $SearchString, 'Medium');
		}

//		DEBUG
/*		echo "<pre>\n";
		print_r($AmazonXml);
		echo "</pre>\n";
*/

		// --- Get results of the Amazon function ---

		$output = '';

		if( false === $AmazonXml ){  // Amazon function was returned false, so AWS is down
			$output = '<!--Amazonのサーバでエラーが起こっているかもしれません。一度ページを再読み込みしてみてください。-->';
			return $output;
		}

		$status = $AmazonXml->Items->Request;

		if( $status->IsValid == 'False' ){ // Request is invalid
			$output = '<!--与えられたリクエストが正しくありません-->';
			return $output;
		}

		// --- Display the product data returned from the XML ---
		$item = $AmazonXml->Items->Item;

		$url = $item->DetailPageURL;
		$Title = $item->ItemAttributes->Title;
		$ProductGroup = $item->ItemAttributes->ProductGroup;

		if( $simple_amazon_settings['layout_type'] != '3' ) {

			$mediumimage = $item->MediumImage->URL;
			if( $mediumimage == '' ) $mediumimage = SIMPLE_AMAZON_PLUGIN_URL . $this->mediumimgfile;
			$smallimage = $item->SmallImage->URL;
			if( $smallimage == '' ) $smallimage = SIMPLE_AMAZON_PLUGIN_URL . $this->smallimgfile;

			switch( $simple_amazon_settings['jacketimgsize'] ) {
				case small: $cdjacketimg = $smallimage; break;
				case medium: $cdjacketimg = $mediumimage; break;
			}
			switch( $simple_amazon_settings['goodsimgsize'] ) {
				case small: $goodsimage = $smallimage; break;
				case medium: $goodsimage = $mediumimage; break;
			}
		}

		if( $simple_amazon_settings['layout_type'] < 2 ) {
			$Manufacturer = $item->ItemAttributes->Manufacturer;
			$Binding = $item->ItemAttributes->Binding;
			$ReleaseDate = $item->ItemAttributes->ReleaseDate;

			$ASIN = $item->ASIN;
			$EANcode = $item->ItemAttributes->EAN;

			if( $simple_amazon_settings['layout_type'] == 0 ) {
				$Price = $item->ItemAttributes->ListPrice->FormattedPrice;
				$LowestUsedPrice = $item->OfferSummary->LowestUsedPrice->FormattedPrice;
				$ISBN10 = $item->ItemAttributes->ISBN;

				if( $LowestUsedPrice != '' ) {
					$usedpricememo = ' ( 中古価格 '. $LowestUsedPrice . ' より )';
				} else {
					$usedpricememo = '';
				}
			}

			switch( $ProductGroup ){
				case Book:
					$Role = $item->ItemAttributes;
					$Pages = $item->ItemAttributes->NumberOfPages;
					$Author = $item->ItemAttributes->Author;
					$PublicationDate = $item->ItemAttributes->PublicationDate;
					break;
				case DVD:
					$RunningTime = $item->ItemAttributes->RunningTime;
					$numofdisc = $item->ItemAttributes->NumberOfDiscs;
					break;
				case Music:
					$Format = $item->ItemAttributes->Format;
					$Artist = $item->ItemAttributes->Artist;
					break;
			}
		}

		if( $simple_amazon_settings['layout_type'] != 3 )
			$output = '<div class="simple-amazon-view">' . "\n";

		if( $ProductGroup == 'Book' ){
			switch ( $simple_amazon_settings['layout_type'] ) {
				case 3: // noimage( Title only )
					$output .= '<a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a>';
					break;
				case 2: // simple( Image + Title )
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $mediumimage . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
					break;
				case 1: // medium( Fully - Price & Code )
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $mediumimage . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
					if( $Author !="" ) {
						$output .= "\t" . "<p><em>著者／訳者：</em>";
						if( count($Author) == 1 ) {
							$output .= $Author; 
						} else {
							foreach($Author as $auth){ $output .= $auth.' '; }
						}
						$output .= '</p>' . "\n";
					}
					$output .= "\t" . "<p><em>出版社：</em>$Manufacturer( $PublicationDate )</p>" . "\n";
					$output .= "\t" . "<p>$Binding ( $Pages ページ )</p>" . "\n";
					break;
				case 0: // Fully
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $mediumimage . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
					if( $Author !="" ) {
						$output .= "\t" . "<p><em>著者／訳者：</em>";
						if( count($Author) == 1 ) {
							$output .= $Author; 
						} else {
							foreach($Author as $auth){ $output .= $auth.' '; }
						}
						$output .= '</p>' . "\n";
					}
					$output .= "\t" . "<p><em>出版社：</em>$Manufacturer( $PublicationDate )</p>" . "\n";
					$output .= "\t" . "<p><em>定価：</em>$Price</p>" . "\n";
					$output .= "\t" . "<p>$Binding ( $Pages ページ )</p>" . "\n";
					$output .= "\t" . "<p>ISBN-10 : $ISBN10</p>" . "\n";
					$output .= "\t" . "<p>ISBN-13 : $EANcode</p>" . "\n";
					break;
			}

		} elseif( $ProductGroup == 'DVD' ) {
			switch ( $simple_amazon_settings['layout_type'] ) {
				case 3: // noimage( Title only )
					$output .= '<a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a>';
					break;
				case 2: // simple( Image + Title )
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $mediumimage . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
					break;
				case 1: // medium( Fully - Price & Code )
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $mediumimage . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
					$output .= "\t" . "<p><em>販売元：</em>$Manufacturer( $ReleaseDate )</p>" . "\n";
					$output .= "\t" . "<p><em>時間：</em>$RunningTime 分</p>" . "\n";
					$output .= "\t" . "<p>$numofdisc" . " 枚組 ( " . $Binding . " )</p>" . "\n";
					break;
				case 0: // Fully
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $mediumimage . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
					$output .= "\t" . "<p><em>販売元：</em>$Manufacturer( $ReleaseDate )</p>" . "\n";
					$output .= "\t" . "<p><em>定価：</em>$Price$usedpricememo</p>" . "\n";
					$output .= "\t" . "<p><em>時間：</em>$RunningTime 分</p>" . "\n";
					$output .= "\t" . "<p>$numofdisc" . " 枚組 ( " . $Binding . " )</p>" . "\n";
					break;
			}
	
		} elseif( $ProductGroup == 'Music' ) {
			switch ( $simple_amazon_settings['layout_type'] ) {
				case 3: // noimage( Title only )
					$output .= '<a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a>';
					break;
				case 2: // simple( Image + Title )
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $cdjacketimg . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
					break;
				case 1: // medium( Fully - Price & Code )
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $cdjacketimg . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a>';
					$output .= ' / ' . $Artist . "</p>" . "\n";
					$output .= "\t" . "<p>$Manufacturer( $ReleaseDate )</p>" . "\n";
					break;
				case 0: // Fully
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $cdjacketimg . '" border="0" alt="" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a>';
					$output .= ' / ' . $Artist;
					$output .= " / $Binding ( $ProductGroup )</p>\n";
					$output .= "\t" . "<p>$Manufacturer( $ReleaseDate )</p>" . "\n";
					$output .= "\t" . "<p><em>定価：</em>$Price$usedpricememo</p>" . "\n";
					break;
			}

		} else {
			switch ( $simple_amazon_settings['layout_type'] ) {
				case 3: // noimage( Title only )
					$output .= '<a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a>';
					break;
				case 2: // simple( Image + Title )
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $goodsimage . '" border="0" alt="' . $Title . '" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
					break;
				case 1: // medium( Fully - Price & Code )
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $goodsimage . '" border="0" alt="' . $Title . '" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>';
					if( $ReleaseDate != '' ) { $output .= "\t" . "<p><em>発売日：</em>$ReleaseDate</p>" . "\n"; }
					break;
				case 0: // Fully
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $goodsimage . '" border="0" alt="' . $Title . '" /></a></p>' . "\n";
					$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>';
					if( $Price != '' ) {
						$output .= "\t" . "<p><em>定価：</em>$Price</p>" . "\n";
					} elseif( $LowestUsedPrice != '' ) {
						$output .= "\t" . "<p><em>中古価格: </em>$LowestUsedPrice より</p>" . "\n";
					}
					$output .= "\t" . "<p>カテゴリ：$Binding</p>\n";
					if( $ReleaseDate != '' ) { $output .= "\t" . "<p><em>発売日：</em>$ReleaseDate</p>" . "\n"; }
					break;
			}
		}

		if( $simple_amazon_settings['layout_type'] != 3 )
			$output .= '<hr class="simple-amazon-clear" /></div>';

		return $output;
	}

}

if(!function_exists('simple_amazon_view')) {
	function simple_amazon_view($Searchstring) {
		global $simpleAmazonView;
		$simpleAmazonView->simple_amazon_view($Searchstring);
		
	}
}

function add_simpleamazon_stylesheet(){
	?>
<link rel="stylesheet" href="<?php echo SIMPLE_AMAZON_PLUGIN_URL; ?>/simple-amazon.css" type="text/css" media="screen" />
	<?php
}

/******************************************************************************
 * Simple Amazon WordPress Plugin Class & Funtcion Define
 *****************************************************************************/

$simpleAmazonView = & new SimpleAmazonView();
$simpleAmazonAdmin = & new SimpleAmazonAdmin();

add_action('wp_head', 'add_simpleamazon_stylesheet');
add_action('admin_menu', array(&$simpleAmazonAdmin, 'simple_amazon_add_options')); 		// Insert the Admin panel.
if ( $_POST['action'] == 'save_options' ){
	add_action('admin_menu', array(&$simpleAmazonAdmin, 'simple_amazon_save_options'));
}

add_filter('the_content', array(&$simpleAmazonView, '_replacestrings'));

?>